diff --git a/gcc/m2/gm2-libs-ch/termios.c b/gcc/m2/gm2-libs-ch/termios.c
index fe7403b3dee..e9cbbf50a17 100644
--- a/gcc/m2/gm2-libs-ch/termios.c
+++ b/gcc/m2/gm2-libs-ch/termios.c
@@ -26,24 +26,28 @@ see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 
 #include "config.h"
 #include "system.h"
-#include "ansidecl.h"
 
 #include "gm2-libs-host.h"
 
+#define _termios_C
+#include "Gtermios.h"
+
+#ifdef HAVE_TERMIOS_H
+# include <termios.h>
+#endif
+
 #ifdef TERMIOS_NEEDS_XOPEN_SOURCE
 #define _XOPEN_SOURCE
 #endif
 
-#if defined(HAVE_TERMIOS_H)
-#include <termios.h>
+#if defined(__cplusplus)
+#define EXTERN extern "C"
+#else
+#define EXTERN
 #endif
 
 #define EXPORT(X) termios##_##X
 
-#ifdef __cplusplus
-extern "C" {
-#endif
-
 typedef enum {
   vintr,
   vquit,
@@ -168,40 +172,25 @@ typedef enum {
   liexten
 } Flag;
 
-/* prototypes.  */
-void *EXPORT (InitTermios) (void);
-void *EXPORT (KillTermios) (struct termios *p);
-int EXPORT (cfgetospeed) (struct termios *t);
-int EXPORT (cfgetispeed) (struct termios *t);
-int EXPORT (cfsetospeed) (struct termios *t, unsigned int b);
-int EXPORT (cfsetispeed) (struct termios *t, unsigned int b);
-int EXPORT (cfsetspeed) (struct termios *t, unsigned int b);
-int EXPORT (tcgetattr) (int fd, struct termios *t);
-int EXPORT (tcsetattr) (int fd, int option, struct termios *t);
-void EXPORT (cfmakeraw) (struct termios *t);
-int EXPORT (tcsendbreak) (int fd, int duration);
-int EXPORT (tcdrain) (int fd);
-int EXPORT (tcflushi) (int fd);
-int EXPORT (tcflusho) (int fd);
-int EXPORT (tcflushio) (int fd);
-int EXPORT (tcflowoni) (int fd);
-int EXPORT (tcflowoffi) (int fd);
-int EXPORT (tcflowono) (int fd);
-int EXPORT (tcflowoffo) (int fd);
-bool EXPORT (GetFlag) (struct termios *t, Flag f, bool *b);
-bool EXPORT (SetFlag) (struct termios *t, Flag f, bool b);
-bool EXPORT (GetChar) (struct termios *t, ControlChar c, char *ch);
-bool EXPORT (SetChar) (struct termios *t, ControlChar c, char ch);
-int EXPORT (tcsnow) (void);
-int EXPORT (tcsflush) (void);
-int EXPORT (tcsdrain) (void);
-bool doSetUnset (tcflag_t *bitset, unsigned int mask, bool value);
-void _M2_termios_init (void);
-void _M2_termios_finish (void);
+int
+doSetUnset (tcflag_t *bitset, unsigned int mask, int value)
+{
+  if (value)
+    (*bitset) |= mask;
+  else
+    (*bitset) &= (~mask);
+  return 1;
+}
+
+
+#ifdef __cplusplus
+extern "C" {
+#endif
 
 /* InitTermios - new data structure.  */
 
-void *EXPORT (InitTermios) (void)
+void *
+EXPORT (InitTermios) (void)
 {
   struct termios *p = (struct termios *)malloc (sizeof (struct termios));
 
@@ -211,50 +200,79 @@ void *EXPORT (InitTermios) (void)
 
 /* KillTermios - delete data structure.  */
 
-void *EXPORT (KillTermios) (struct termios *p)
+void *
+EXPORT (KillTermios) (termios_TERMIOS p)
 {
   free (p);
   return NULL;
 }
 
-/* tcsnow - return the value of TCSANOW.  */
+/* tcsnow return the value of TCSANOW.  */
 
-int EXPORT (tcsnow) (void) { return TCSANOW; }
+int
+EXPORT (tcsnow) (void)
+{
+  return TCSANOW;
+}
 
-/* tcsdrain - return the value of TCSADRAIN.  */
+/* tcsdrain return the value of TCSADRAIN.  */
 
-int EXPORT (tcsdrain) (void) { return TCSADRAIN; }
+int
+EXPORT (tcsdrain) (void)
+{
+  return TCSADRAIN;
+}
 
-/* tcsflush - return the value of TCSAFLUSH.  */
+/* tcsflush return the value of TCSAFLUSH.  */
 
-int EXPORT (tcsflush) (void) { return TCSAFLUSH; }
+int
+EXPORT (tcsflush) (void)
+{
+  return TCSAFLUSH;
+}
 
-/* cfgetospeed - return output baud rate.  */
+/* cfgetospeed return output baud rate.  */
 
-int EXPORT (cfgetospeed) (struct termios *t) { return cfgetospeed (t); }
+int
+EXPORT (cfgetospeed) (termios_TERMIOS _t)
+{
+  struct termios *t = (termios *)_t;
+  return cfgetospeed (t);
+}
 
-/* cfgetispeed - return input baud rate.  */
+/* cfgetispeed return input baud rate.  */
 
-int EXPORT (cfgetispeed) (struct termios *t) { return cfgetispeed (t); }
+int
+EXPORT (cfgetispeed) (termios_TERMIOS _t)
+{
+  struct termios *t = (termios *)_t;
+  return cfgetispeed (t);
+}
 
-/* cfsetospeed - set output baud rate.  */
+/* cfsetospeed set output baud rate.  */
 
-int EXPORT (cfsetospeed) (struct termios *t, unsigned int b)
+int
+EXPORT (cfsetospeed) (termios_TERMIOS _t, unsigned int b)
 {
+  struct termios *t = (termios *)_t;
   return cfsetospeed (t, b);
 }
 
-/* cfsetispeed - set input baud rate.  */
+/* cfsetispeed set input baud rate.  */
 
-int EXPORT (cfsetispeed) (struct termios *t, unsigned int b)
+int
+EXPORT (cfsetispeed) (termios_TERMIOS _t, unsigned int b)
 {
+  struct termios *t = (termios *)_t;
   return cfsetispeed (t, b);
 }
 
-/* cfsetspeed - set input and output baud rate.  */
+/* cfsetspeed set input and output baud rate.  */
 
-int EXPORT (cfsetspeed) (struct termios *t, unsigned int b)
+int
+EXPORT (cfsetspeed) (termios_TERMIOS _t, unsigned int b)
 {
+  struct termios *t = (termios *)_t;
   int val = cfsetispeed (t, b);
   if (val == 0)
     return cfsetospeed (t, b);
@@ -262,43 +280,55 @@ int EXPORT (cfsetspeed) (struct termios *t, unsigned int b)
   return val;
 }
 
-/* tcgetattr - get state of, fd, into, t.  */
+/* tcgetattr get state of fd into t.  */
 
-int EXPORT (tcgetattr) (int fd, struct termios *t)
+int
+EXPORT (tcgetattr) (int fd, termios_TERMIOS _t)
 {
+  struct termios *t = (termios *)_t;
   return tcgetattr (fd, t);
 }
 
-/* tcsetattr - set state of, fd, to, t, using option.  */
+/* tcsetattr set state of fd to t using option.  */
 
-int EXPORT (tcsetattr) (int fd, int option, struct termios *t)
+int
+EXPORT (tcsetattr) (int fd, int option, termios_TERMIOS _t)
 {
+  struct termios *t = (termios *)_t;
   return tcsetattr (fd, option, t);
 }
 
-/* cfmakeraw - sets the terminal to raw mode.  */
+/* cfmakeraw sets the terminal to raw mode.  */
 
-void EXPORT (cfmakeraw) (struct termios *t)
+void
+EXPORT (cfmakeraw) (termios_TERMIOS _t)
 {
 #if defined(HAVE_CFMAKERAW)
+  struct termios *t = (termios *)_t;
   cfmakeraw (t);
 #endif
 }
 
-/* tcsendbreak - send zero bits for duration.  */
+/* tcsendbreak send zero bits for duration.  */
 
-int EXPORT (tcsendbreak) (int fd, int duration)
+int
+EXPORT (tcsendbreak) (int fd, int duration)
 {
   return tcsendbreak (fd, duration);
 }
 
-/* tcdrain - waits for pending output to be written on, fd.  */
+/* tcdrain waits for pending output to be written on fd.  */
 
-int EXPORT (tcdrain) (int fd) { return tcdrain (fd); }
+int
+EXPORT (tcdrain) (int fd)
+{
+  return tcdrain (fd);
+}
 
-/* tcflushi - flush input.  */
+/* tcflushi flush input.  */
 
-int EXPORT (tcflushi) (int fd)
+int
+EXPORT (tcflushi) (int fd)
 {
 #if defined(TCIFLUSH)
   return tcflush (fd, TCIFLUSH);
@@ -307,9 +337,10 @@ int EXPORT (tcflushi) (int fd)
 #endif
 }
 
-/* tcflusho - flush output.  */
+/* tcflusho flush output.  */
 
-int EXPORT (tcflusho) (int fd)
+int
+EXPORT (tcflusho) (int fd)
 {
 #if defined(TCOFLUSH)
   return tcflush (fd, TCOFLUSH);
@@ -318,9 +349,10 @@ int EXPORT (tcflusho) (int fd)
 #endif
 }
 
-/* tcflushio - flush input and output.  */
+/* tcflushio flush input and output.  */
 
-int EXPORT (tcflushio) (int fd)
+int
+EXPORT (tcflushio) (int fd)
 {
 #if defined(TCIOFLUSH)
   return tcflush (fd, TCIOFLUSH);
@@ -329,9 +361,10 @@ int EXPORT (tcflushio) (int fd)
 #endif
 }
 
-/* tcflowoni - restart input on, fd.  */
+/* tcflowoni restart input on fd.  */
 
-int EXPORT (tcflowoni) (int fd)
+int
+EXPORT (tcflowoni) (int fd)
 {
 #if defined(TCION)
   return tcflow (fd, TCION);
@@ -340,9 +373,10 @@ int EXPORT (tcflowoni) (int fd)
 #endif
 }
 
-/* tcflowoffi - stop input on, fd.  */
+/* tcflowoffi stop input on fd.  */
 
-int EXPORT (tcflowoffi) (int fd)
+int
+EXPORT (tcflowoffi) (int fd)
 {
 #if defined(TCIOFF)
   return tcflow (fd, TCIOFF);
@@ -351,9 +385,10 @@ int EXPORT (tcflowoffi) (int fd)
 #endif
 }
 
-/* tcflowono - restart output on, fd.  */
+/* tcflowono restart output on fd.  */
 
-int EXPORT (tcflowono) (int fd)
+int
+EXPORT (tcflowono) (int fd)
 {
 #if defined(TCOON)
   return tcflow (fd, TCOON);
@@ -362,9 +397,10 @@ int EXPORT (tcflowono) (int fd)
 #endif
 }
 
-/* tcflowoffo - stop output on, fd.  */
+/* tcflowoffo stop output on fd.  */
 
-int EXPORT (tcflowoffo) (int fd)
+int
+EXPORT (tcflowoffo) (int fd)
 {
 #if defined(TCOOFF)
   return tcflow (fd, TCOOFF);
@@ -373,23 +409,14 @@ int EXPORT (tcflowoffo) (int fd)
 #endif
 }
 
-/* doSetUnset applies mask or undoes mask depending upon value and returns true.  */
+/* GetFlag sets a flag value from t in b and returns TRUE if
+   t supports f.  */
 
 bool
-doSetUnset (tcflag_t *bitset, unsigned int mask, bool value)
-{
-  if (value)
-    (*bitset) |= mask;
-  else
-    (*bitset) &= (~mask);
-  return true;
-}
-
-/* GetFlag sets a flag value from t in b and returns true if t supports f.  */
-
-bool
-EXPORT (GetFlag) (struct termios *t, Flag f, bool *b)
+EXPORT (GetFlag) (termios_TERMIOS _t, termios_Flag _f, bool *b)
 {
+  Flag f = (Flag) _f;
+  struct termios *t = (termios *)_t;
   switch (f)
     {
 
@@ -1069,15 +1096,17 @@ EXPORT (GetFlag) (struct termios *t, Flag f, bool *b)
   return false;
 }
 
-/* SetFlag - sets a flag value in, t, to, b, and returns TRUE if this
+/* SetFlag sets a flag value in t to b and returns TRUE if this
    flag value is supported.  */
 
 bool
-EXPORT (SetFlag) (struct termios *t, Flag f, bool b)
+EXPORT (SetFlag) (termios_TERMIOS _t, termios_Flag _f, bool b)
 {
+  struct termios *t = (struct termios *) _t;
+  Flag f = (Flag) _f;
+
   switch (f)
     {
-
     case ignbrk:
 #if defined(IGNBRK)
       return doSetUnset (&t->c_iflag, IGNBRK, b);
@@ -1658,12 +1687,14 @@ EXPORT (SetFlag) (struct termios *t, Flag f, bool b)
   return false;
 }
 
-/* GetChar sets a CHAR ch value from t and returns true if this
+/* GetChar sets a CHAR ch value from t and returns true/false if this
    value is supported.  */
 
 bool
-EXPORT (GetChar) (struct termios *t, ControlChar c, char *ch)
+EXPORT (GetChar) (termios_TERMIOS _t, termios_ControlChar _c, char *ch)
 {
+  ControlChar c = (ControlChar) _c;
+  struct termios *t = (termios *)_t;
   switch (c)
     {
 
@@ -1791,11 +1822,14 @@ EXPORT (GetChar) (struct termios *t, ControlChar c, char *ch)
     }
 }
 
-/* SetChar sets a CHAR value in t and returns true if c is supported.  */
+/* SetChar sets a CHAR value in t and returns true/false if c is
+   supported.  */
 
 bool
-EXPORT (SetChar) (struct termios *t, ControlChar c, char ch)
+EXPORT (SetChar) (termios_TERMIOS _t, termios_ControlChar _c, char ch)
 {
+  ControlChar c = (ControlChar) _c;
+  struct termios *t = (termios *)_t;
   switch (c)
     {
 
@@ -1924,12 +1958,12 @@ EXPORT (SetChar) (struct termios *t, ControlChar c, char ch)
 }
 
 void
-_M2_termios_init (void)
+_M2_termios_init (int argc, char *argv[], char *envp[])
 {
 }
 
 void
-_M2_termios_finish (void)
+_M2_termios_fini (int argc, char *argv[], char *envp[])
 {
 }
 
diff --git a/gcc/m2/mc-boot-ch/GSysExceptions.c b/gcc/m2/mc-boot-ch/GSysExceptions.c
index d16197dbcc7..de8bab91c57 100644
--- a/gcc/m2/mc-boot-ch/GSysExceptions.c
+++ b/gcc/m2/mc-boot-ch/GSysExceptions.c
@@ -24,6 +24,16 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 
 #include "gm2-libs-host.h"
 
+#ifdef MC_M2
+#include "GSysExceptions.h"
+#define DECL_PROC_T(X) SysExceptions_PROCEXCEPTION X
+#define PROC_FUNC(X) X.proc
+#else
+#define DECL_PROC_T(X) void (*X) (void *)
+#define PROC_FUNC(X) X
+#endif
+
+#undef EXTERN
 #if defined(__cplusplus)
 #define EXTERN extern "C"
 #else
@@ -68,13 +78,11 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 #define SIGSYS 31      /* Bad system call.  */
 #define SIGUNUSED 31
 
-
     (indexException,     rangeException,         caseSelectException,  invalidLocation,
      functionException,  wholeValueException,    wholeDivException,    realValueException,
      realDivException,   complexValueException,  complexDivException,  protException,
      sysException,       coException,            exException
     );
-
 #endif
 
 /* wholeDivException and realDivException are caught by SIGFPE
@@ -106,6 +114,7 @@ static void (*systemProc) (void *);
 static void (*coroutineProc) (void *);
 static void (*exceptionProc) (void *);
 
+
 static void
 sigbusDespatcher (int signum, siginfo_t *info, void *ucontext)
 {
@@ -159,32 +168,39 @@ sigfpeDespatcher (int signum, siginfo_t *info, void *ucontext)
 
 EXTERN
 void
-SysExceptions_InitExceptionHandlers (
-    void (*indexf) (void *), void (*range) (void *), void (*casef) (void *),
-    void (*invalidloc) (void *), void (*function) (void *),
-    void (*wholevalue) (void *), void (*wholediv) (void *),
-    void (*realvalue) (void *), void (*realdiv) (void *),
-    void (*complexvalue) (void *), void (*complexdiv) (void *),
-    void (*protection) (void *), void (*systemf) (void *),
-    void (*coroutine) (void *), void (*exception) (void *))
+SysExceptions_InitExceptionHandlers (DECL_PROC_T(indexf),
+				     DECL_PROC_T(range),
+				     DECL_PROC_T(casef),
+				     DECL_PROC_T(invalidloc),
+				     DECL_PROC_T(function),
+				     DECL_PROC_T(wholevalue),
+				     DECL_PROC_T(wholediv),
+				     DECL_PROC_T(realvalue),
+				     DECL_PROC_T(realdiv),
+				     DECL_PROC_T(complexvalue),
+				     DECL_PROC_T(complexdiv),
+				     DECL_PROC_T(protection),
+				     DECL_PROC_T(systemf),
+				     DECL_PROC_T(coroutine),
+				     DECL_PROC_T(exception))
 {
   struct sigaction old;
 
-  indexProc = indexf;
-  rangeProc = range;
-  caseProc = casef;
-  invalidlocProc = invalidloc;
-  functionProc = function;
-  wholevalueProc = wholevalue;
-  wholedivProc = wholediv;
-  realvalueProc = realvalue;
-  realdivProc = realdiv;
-  complexvalueProc = complexvalue;
-  complexdivProc = complexdiv;
-  protectionProc = protection;
-  systemProc = systemf;
-  coroutineProc = coroutine;
-  exceptionProc = exception;
+  indexProc = PROC_FUNC (indexf);
+  rangeProc = PROC_FUNC (range);
+  caseProc = PROC_FUNC (casef);
+  invalidlocProc = PROC_FUNC (invalidloc);
+  functionProc = PROC_FUNC (function);
+  wholevalueProc = PROC_FUNC (wholevalue);
+  wholedivProc = PROC_FUNC (wholediv);
+  realvalueProc = PROC_FUNC (realvalue);
+  realdivProc = PROC_FUNC (realdiv);
+  complexvalueProc = PROC_FUNC (complexvalue);
+  complexdivProc = PROC_FUNC (complexdiv);
+  protectionProc = PROC_FUNC (protection);
+  systemProc = PROC_FUNC (systemf);
+  coroutineProc = PROC_FUNC (coroutine);
+  exceptionProc = PROC_FUNC (exception);
 
   sigbus.sa_sigaction = sigbusDespatcher;
   sigbus.sa_flags = (SA_SIGINFO);
@@ -211,13 +227,21 @@ SysExceptions_InitExceptionHandlers (
 #else
 EXTERN
 void
-SysExceptions_InitExceptionHandlers (void *indexf, void *range, void *casef,
-                                     void *invalidloc, void *function,
-                                     void *wholevalue, void *wholediv,
-                                     void *realvalue, void *realdiv,
-                                     void *complexvalue, void *complexdiv,
-                                     void *protection, void *systemf,
-                                     void *coroutine, void *exception)
+SysExceptions_InitExceptionHandlers (DECL_PROC_T(indexf),
+				     DECL_PROC_T(range),
+				     DECL_PROC_T(casef),
+				     DECL_PROC_T(invalidloc),
+				     DECL_PROC_T(function),
+				     DECL_PROC_T(wholevalue),
+				     DECL_PROC_T(wholediv),
+				     DECL_PROC_T(realvalue),
+				     DECL_PROC_T(realdiv),
+				     DECL_PROC_T(complexvalue),
+				     DECL_PROC_T(complexdiv),
+				     DECL_PROC_T(protection),
+				     DECL_PROC_T(systemf),
+				     DECL_PROC_T(coroutine),
+				     DECL_PROC_T(exception))
 {
 }
 #endif
diff --git a/gcc/m2/mc-boot-ch/Glibc.c b/gcc/m2/mc-boot-ch/Glibc.c
index 5ad1711bc64..2f6d31397ba 100644
--- a/gcc/m2/mc-boot-ch/Glibc.c
+++ b/gcc/m2/mc-boot-ch/Glibc.c
@@ -343,10 +343,10 @@ libc_creat (char *p, mode_t mode)
 
 EXTERN
 int
-libc_open (void *p, int oflag, int mode)
+libc_open (void *p, int flags, int mode)
 {
-  tracedb_open (p, oflag, mode);
-  int result = open (reinterpret_cast <char *> (p), oflag, mode);
+  tracedb_open (p, flags, mode);
+  int result = open (reinterpret_cast <char *> (p), flags, mode);
   tracedb_result (result);
   return result;
 }
diff --git a/gcc/m2/mc-boot-ch/Gtermios.cc b/gcc/m2/mc-boot-ch/Gtermios.cc
index 99f003f6152..fe20afb767f 100644
--- a/gcc/m2/mc-boot-ch/Gtermios.cc
+++ b/gcc/m2/mc-boot-ch/Gtermios.cc
@@ -1,4 +1,4 @@
-/* Gtermios.cc handwritten module for mc.
+/* Gtermios.c handwritten module for mc.
 
 Copyright (C) 2010-2024 Free Software Foundation, Inc.
 Contributed by Gaius Mulley <gaius@glam.ac.uk>.
@@ -24,6 +24,9 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 
 #include "gm2-libs-host.h"
 
+#define _termios_C
+#include "Gtermios.h"
+
 #ifdef HAVE_TERMIOS_H
 # include <termios.h>
 #endif
@@ -193,13 +196,13 @@ EXPORT (InitTermios) (void)
 /* KillTermios - delete data structure.  */
 
 void *
-EXPORT (KillTermios) (struct termios *p)
+EXPORT (KillTermios) (termios_TERMIOS p)
 {
   free (p);
   return NULL;
 }
 
-/* tcsnow - return the value of TCSANOW.  */
+/* tcsnow return the value of TCSANOW.  */
 
 int
 EXPORT (tcsnow) (void)
@@ -207,7 +210,7 @@ EXPORT (tcsnow) (void)
   return TCSANOW;
 }
 
-/* tcsdrain - return the value of TCSADRAIN.  */
+/* tcsdrain return the value of TCSADRAIN.  */
 
 int
 EXPORT (tcsdrain) (void)
@@ -215,7 +218,7 @@ EXPORT (tcsdrain) (void)
   return TCSADRAIN;
 }
 
-/* tcsflush - return the value of TCSAFLUSH.  */
+/* tcsflush return the value of TCSAFLUSH.  */
 
 int
 EXPORT (tcsflush) (void)
@@ -223,43 +226,48 @@ EXPORT (tcsflush) (void)
   return TCSAFLUSH;
 }
 
-/* cfgetospeed - return output baud rate.  */
+/* cfgetospeed return output baud rate.  */
 
 int
-EXPORT (cfgetospeed) (struct termios *t)
+EXPORT (cfgetospeed) (termios_TERMIOS _t)
 {
+  struct termios *t = (termios *)_t;
   return cfgetospeed (t);
 }
 
-/* cfgetispeed - return input baud rate.  */
+/* cfgetispeed return input baud rate.  */
 
 int
-EXPORT (cfgetispeed) (struct termios *t)
+EXPORT (cfgetispeed) (termios_TERMIOS _t)
 {
+  struct termios *t = (termios *)_t;
   return cfgetispeed (t);
 }
 
-/* cfsetospeed - set output baud rate.  */
+/* cfsetospeed set output baud rate.  */
 
 int
-EXPORT (cfsetospeed) (struct termios *t, unsigned int b)
+EXPORT (cfsetospeed) (termios_TERMIOS _t, unsigned int b)
 {
+  struct termios *t = (termios *)_t;
   return cfsetospeed (t, b);
 }
 
-/* cfsetispeed - set input baud rate.  */
+/* cfsetispeed set input baud rate.  */
 
 int
-EXPORT (cfsetispeed) (struct termios *t, unsigned int b)
+EXPORT (cfsetispeed) (termios_TERMIOS _t, unsigned int b)
 {
+  struct termios *t = (termios *)_t;
   return cfsetispeed (t, b);
 }
 
-/* cfsetspeed - set input and output baud rate.  */
+/* cfsetspeed set input and output baud rate.  */
 
 int
-EXPORT (cfsetspeed) (struct termios *t, unsigned int b)
+EXPORT (cfsetspeed) (termios_TERMIOS _t, unsigned int b)
 {
+  struct termios *t = (termios *)_t;
   int val = cfsetispeed (t, b);
   if (val == 0)
     return cfsetospeed (t, b);
@@ -267,33 +275,36 @@ EXPORT (cfsetspeed) (struct termios *t, unsigned int b)
   return val;
 }
 
-/* tcgetattr - get state of, fd, into, t.  */
+/* tcgetattr get state of fd into t.  */
 
 int
-EXPORT (tcgetattr) (int fd, struct termios *t)
+EXPORT (tcgetattr) (int fd, termios_TERMIOS _t)
 {
+  struct termios *t = (termios *)_t;
   return tcgetattr (fd, t);
 }
 
-/* tcsetattr - set state of, fd, to, t, using option.  */
+/* tcsetattr set state of fd to t using option.  */
 
 int
-EXPORT (tcsetattr) (int fd, int option, struct termios *t)
+EXPORT (tcsetattr) (int fd, int option, termios_TERMIOS _t)
 {
+  struct termios *t = (termios *)_t;
   return tcsetattr (fd, option, t);
 }
 
-/* cfmakeraw - sets the terminal to raw mode.  */
+/* cfmakeraw sets the terminal to raw mode.  */
 
 void
-EXPORT (cfmakeraw) (struct termios *t)
+EXPORT (cfmakeraw) (termios_TERMIOS _t)
 {
 #if defined(HAVE_CFMAKERAW)
+  struct termios *t = (termios *)_t;
   cfmakeraw (t);
 #endif
 }
 
-/* tcsendbreak - send zero bits for duration.  */
+/* tcsendbreak send zero bits for duration.  */
 
 int
 EXPORT (tcsendbreak) (int fd, int duration)
@@ -301,7 +312,7 @@ EXPORT (tcsendbreak) (int fd, int duration)
   return tcsendbreak (fd, duration);
 }
 
-/* tcdrain - waits for pending output to be written on, fd.  */
+/* tcdrain waits for pending output to be written on fd.  */
 
 int
 EXPORT (tcdrain) (int fd)
@@ -309,7 +320,7 @@ EXPORT (tcdrain) (int fd)
   return tcdrain (fd);
 }
 
-/* tcflushi - flush input.  */
+/* tcflushi flush input.  */
 
 int
 EXPORT (tcflushi) (int fd)
@@ -321,7 +332,7 @@ EXPORT (tcflushi) (int fd)
 #endif
 }
 
-/* tcflusho - flush output.  */
+/* tcflusho flush output.  */
 
 int
 EXPORT (tcflusho) (int fd)
@@ -333,7 +344,7 @@ EXPORT (tcflusho) (int fd)
 #endif
 }
 
-/* tcflushio - flush input and output.  */
+/* tcflushio flush input and output.  */
 
 int
 EXPORT (tcflushio) (int fd)
@@ -345,7 +356,7 @@ EXPORT (tcflushio) (int fd)
 #endif
 }
 
-/* tcflowoni - restart input on, fd.  */
+/* tcflowoni restart input on fd.  */
 
 int
 EXPORT (tcflowoni) (int fd)
@@ -357,7 +368,7 @@ EXPORT (tcflowoni) (int fd)
 #endif
 }
 
-/* tcflowoffi - stop input on, fd.  */
+/* tcflowoffi stop input on fd.  */
 
 int
 EXPORT (tcflowoffi) (int fd)
@@ -369,7 +380,7 @@ EXPORT (tcflowoffi) (int fd)
 #endif
 }
 
-/* tcflowono - restart output on, fd.  */
+/* tcflowono restart output on fd.  */
 
 int
 EXPORT (tcflowono) (int fd)
@@ -381,7 +392,7 @@ EXPORT (tcflowono) (int fd)
 #endif
 }
 
-/* tcflowoffo - stop output on, fd.  */
+/* tcflowoffo stop output on fd.  */
 
 int
 EXPORT (tcflowoffo) (int fd)
